UNIT StarfieldUnit;

{$MODE Delphi}

INTERFACE

USES
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

TYPE
  TStar = CLASS
  private
    x, y, z: integer;
    zSpd: integer;
    sCol: TColor;
    xScr, yScr: integer;
  public
    PROCEDURE NeuerStern;
    PROCEDURE Zeichnen;
    PROCEDURE Bewegen;
  END;

TYPE

  { TForm1 }

  TForm1 = CLASS(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    Timer1: TTimer;
    PROCEDURE Button1Click (Sender: TObject);
    PROCEDURE Button2Click (Sender: TObject);
    PROCEDURE FormCreate (Sender: TObject);
    PROCEDURE FormResize (Sender: TObject);
    PROCEDURE Timer1Timer (Sender: TObject);
    PROCEDURE SterneInit;
  private
    { Private declarations }
  public
    { Public declarations }

  END;

VAR
  Form1: TForm1;

IMPLEMENTATION

{$R *.lfm}

VAR
  Spd: integer = 1;
  MaxSpd: integer = 3;
  MaxZ: integer = 255;
  NumStars: integer;
  Entf: integer = 255;
  Breite, Hoehe, Breite2, Hoehe2: integer;
  s: TStar;


PROCEDURE TStar.NeuerStern;
BEGIN
  //neuen Stern erzeugen
  s := TStar.Create;
  s.x := random (Breite) - Breite2;
  s.y := random (Hoehe) - Hoehe2;
  s.z := random (255) + 1;
  s.zSpd := Spd;
  s.sCol := clWhite;
END;

PROCEDURE TStar.Zeichnen;
BEGIN
  //Zeichnen
  s.xScr := round (s.x / s.z * Entf) + Breite2;
  s.yScr := round (s.y / s.z * Entf) + Hoehe2;
  form1.Panel1.Canvas.Pixels[s.xScr, s.yScr] := clwhite;
END;

PROCEDURE TStar.Bewegen;
BEGIN
  //Bewegen
  IF s.z > 0 THEN s.z := s.z - Spd;
END;

PROCEDURE TForm1.FormCreate (Sender: TObject);
BEGIN
  randomize;
  Breite := Panel1.Width;
  Hoehe := Panel1.Height;
  Breite2 := Breite div 2;
  Hoehe2 := Hoehe div 2;
  NumStars := 500;
  SterneInit;
END;

PROCEDURE TForm1.Button1Click (Sender: TObject);
BEGIN
  SterneInit;
END;

PROCEDURE TForm1.Button2Click (Sender: TObject);
BEGIN
  Panel1.Canvas.Clear;
END;

PROCEDURE TForm1.FormResize (Sender: TObject);
BEGIN
  Breite := Form1.Width;
  Hoehe := Form1.Height;
END;

PROCEDURE TForm1.Timer1Timer (Sender: TObject);
VAR
  i: integer;
BEGIN

  FOR i := 1 TO NumStars DO BEGIN

    IF s.z > 0 THEN BEGIN
      s.Zeichnen;
      s.Bewegen;
      //Panel1.Canvas.Clear;

      //Farbe berechnen
      //StarCol := RGBToColor (stern[i].sCol, stern[i].sCol, stern[i].sCol);

      //wenn Stern aus Schirm -> neuen Stern erzeugen
      //if s.z=0 then s.Destroy;
    END;
  END;

END;

PROCEDURE TForm1.SterneInit;
VAR
  i: integer;
BEGIN
  FOR i := 1 TO NumStars DO BEGIN
    s.NeuerStern;
  END;
END;

END.
